import java.util.Arrays;

public class Klausur {
	public static void main(String[] args) {
		String test = "Weimar 12345678 Peter Zwegat";
		String test2 = "Erfurt 12345678 Peter Zwegat";
		checkAnmeldung(test);
	}
	
	public static void checkAnmeldung(String text) {
		String[] parts = text.split(" ");
		try {
			checkParts(parts);
			checkOrt(parts[0]);
			checkMatrikel(parts[1]);
			String[] names = {parts[2], parts[3]};
			checkName(names);
			
		} catch (WrongTownException | WrongLengthException | WrongMatrikelException | WrongNameException e) {
			e.printStackTrace();
		} 
	}
	
	public static void checkParts(String[] parts) throws WrongLengthException {
		if(parts.length != 4) {
			throw new WrongLengthException("String besteht aus " + parts.length + " Zeichen!");
		}
	}
	
	public static void checkOrt(String ort) throws WrongTownException{
		if(!ort.equals("Weimar")) {
			throw new WrongTownException("Falscher Ort! Anmeldung in " + ort);
		}
	}
	
	public static void checkMatrikel(String matrikel) throws WrongMatrikelException {
		char[] parts = matrikel.toCharArray();
		if(parts.length != 8) {
			throw new WrongMatrikelException("Matrikelnummer hat falsche Länge! " + parts.length + " " + matrikel);
		}
		try {
			int m = Integer.parseInt(matrikel);
		} catch(NumberFormatException e) {
			throw new WrongMatrikelException("Matrikelnummer besteht nicht zu 100% aus Zahlen! " + matrikel);
		}
	}
	
	public static void checkName(String[] names) throws WrongNameException {
		if(names.length != 2) {
			throw new WrongNameException("Falsche Anzahl an Namen übergeben");
		}
		String characters = "abcdefghijklmnopqrstuvwxyz";
		for(String n : names) {
			n = n.toLowerCase();
			for(int i=0; i<n.length(); i++) {
				char c = n.charAt(i);
				if(characters.indexOf(c) == -1) {
					throw new WrongNameException("Name falsch formatiert " + n);
				}
			}
		}
	}
}
